/*
 * Copyright (c) 2009, Olivier MATZ <zer0@droids-corp.org>
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _PARSE_MONITOR_H_
#define _PARSE_MONITOR_H_

#include <sys/queue.h>
#include <cmdline_parse.h>

struct monitor_reg {
	LIST_ENTRY(monitor_reg) next;
	const char *desc;
	const char *atcmd;
};

LIST_HEAD(monitor_reg_list, monitor_reg);

/* data is a pointer to a list */
struct token_monitor_data {
	struct monitor_reg_list *list;
};

struct token_monitor {
	struct cmdline_token_hdr hdr;
	struct token_monitor_data monitor_data;
};
typedef struct token_monitor parse_token_monitor_t;

extern struct cmdline_token_ops token_monitor_ops;

#define TOKEN_MONITOR_INITIALIZER(structure, field, monitor_ptr)  \
{								    \
	.hdr = {						    \
		.ops = &token_monitor_ops,			    \
		.offset = offsetof(structure, field),		    \
	},							    \
		.monitor_data = {				    \
		.list = monitor_ptr,				    \
	},							    \
}

#endif /* _PARSE_MONITOR_H_ */
